function c = concover(a,inp)
% Compute the coverage. If the input is of size 2 then 4 cells are
% allocated for the coverage for FF (1) FT (2) TF (3) TT (4). If the input
% is of size 3 then an eight element cell is used.

% (c) Yogananda Jeppu yvj_2000@yahoo.com

if length(inp) == 2
    index=round(inp(1)+inp(2)*2+1);
    a(index)=a(index)+1;
elseif length(inp) == 3
    index=round(inp(1)+inp(2)*2+inp(3)*4+1);
    a(index)=a(index)+1;
end
c=a;
