% This loads the data from each random stored file and runs it on the
% mutants to check how many are killed.
clear all

% The mutants have been generated for the different classes and put in the
% subdirectories defined below.

dirdata={
    'cd Arithmetic'
    'cd Relation'
    'cd Data'
    'cd filter'
    'cd logical'
    'cd variable'};
warning off
id=0;ik=0;ia=0;
for jj = 1:length(dirdata)
    eval(dirdata{jj})
    disp(dirdata{jj});
    files=dir('Mutan*.m');
    ilen=size(files,1);
    killx=zeros(ilen,1);
    for ixx = 1:6
        eval(['load ..\rand_input' num2str(ixx)])
        eval(['load ..\results_rand' num2str(ixx)])
%                 eval(['load ..\taguchi_input' num2str(ixx)])
%                 eval(['load ..\results_taguchi' num2str(ixx)])
        INP1 = inp1;
        INP2 = inp2;
        INP3 = inp3;
        INP4 = inp4;
        INP5 = inp5;
        INP6 = inp6;
        INP7 = inp7;
        INP8 = inp8;
        INP9 = inp9;
        INP10 = inp10;
        Mutant0
        simout1=OUT(:,1);
        simout2=OUT(:,2);
        simout3=OUT(:,3);
        simout4=OUT(:,4);
        simout5=OUT(:,5);
        simout6=OUT(:,6);
        simout7=OUT(:,7);
          
        
        for ix = 1:ilen
            err=0;
            if killx(ix) == 0
                try
                    mdlfile = files(ix).name;
                    runfile = regexprep(files(ix).name,'.m','');
                    eval(runfile)
                    if err > 1e-4
                        disp([mdlfile ' mutant is killed (err=' num2str(err) ') in ' dirdata{jj} ]);
                        killx(ix) = 1;
                    else
                        disp([mdlfile ' mutant is alive']);
                        
                    end
                catch
                    disp([mdlfile ' mutant is dud']);
                    killx(ix) = 2;
                    
                end
            end
        end
    end
    
    diary ..\result.txt
    disp('==========================================================================');
    disp('  ');
    itemp=find(killx == 2);
    if ~isempty(itemp)
        id = id+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is a dud in ' dirdata{jj}]);
        end
    end
    
    itemp=find(killx == 1);
    if ~isempty(itemp)
        ik = ik+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is killed in ' dirdata{jj}]);
        end
    end
    
    
    itemp=find(killx == 0);
    if ~isempty(itemp)
        ia = ia+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is alive in ' dirdata{jj}]);
          
        end
    end
tot=ia+ik;
disp(['Percentage Killed ' num2str(100*ik/tot)]);
disp(['Percentage Alive ' num2str(100*ia/tot)]);
disp(['Percentage Dud ' num2str(100*id/(tot+id))]);

    diary off
    cd ..
    
end
diary result.txt
disp('=========================== FINAL ================================');
tot=ia+ik;
disp(['Percentage Killed ' num2str(100*ik/tot)]);
disp(['Percentage Alive ' num2str(100*ia/tot)]);
disp(['Percentage Dud ' num2str(100*id/(tot+id))]);
diary off



