% This loads the data from each random stored file and runs it on the
% mutants to check how many are killed. These mutants have been created by
% the randomizer script.

% (c) Yogananda Jeppu yvj_2000@yahoo.com

clear all
dirdata={
    'cd Lines'
    'cd Logic'
    'cd Backlash'
    'cd DataType'
    'cd Filter'
    'cd Integrator'
    'cd Saturation'
    'cd Sum'
    'cd Switch'
    'cd Delay'
    'cd Lookup'
    'cd Relational'};
warning off
id=0;ik=0;ia=0;
for jj = 1:length(dirdata)
    eval(dirdata{jj})
    disp(dirdata{jj});
    files=dir('D*.mdl');
    ilen=size(files,1);
    killx=zeros(ilen,1);
    for ixx = 1:6
        eval(['load ..\rand_input' num2str(ixx)])
        eval(['load ..\results_rand' num2str(ixx)])
%         eval(['load ..\taguchi_input' num2str(ixx)])
%         eval(['load ..\results_taguchi' num2str(ixx)])
        
        SIM=[simout1  simout2  simout3  simout4  simout5  simout6  simout7];
        for ix = 1:ilen
            if killx(ix) ~= 1
                try
                    mdlfile = files(ix).name;
                    bdclose all
                    sim(mdlfile);
                    err=max(max(abs(SIM-simout)));
                    if err > 1e-4
                        disp([mdlfile ' mutant is killed']);
                        killx(ix) = 1;
                    else
                        disp([mdlfile ' mutant is alive']);
                        
                    end
                catch
                    % A dud mutant cannot execute due to some program
                    % error. A data type  mismatch may also cause this. The
                    % Try Catch traps such error sna continues with the execution.  
                    disp([mdlfile ' mutant is dud']);
                    killx(ix) = 2;
                    
                end
            end
        end
    end
    
    diary ..\result.txt
    disp('==========================================================================');
    disp('  ');
    itemp=find(killx == 2);
    if ~isempty(itemp)
        id = id+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is a dud in ' dirdata{jj}]);
        end
    end
    
    itemp=find(killx == 1);
    if ~isempty(itemp)
        ik = ik+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is killed in ' dirdata{jj}]);
        end
    end
    
    
    itemp=find(killx == 0);
    if ~isempty(itemp)
        ia = ia+length(itemp);
        for it = 1:length(itemp)
            disp(['Mutant ' files(itemp(it)).name ' is alive in ' dirdata{jj}]);
            s = regexprep(files(itemp(it)).name,'.mdl','_changes.txt');
            eval(['type ' s]);
            
        end
    end
    diary off
    cd ..
    
end
diary result.txt
tot=ia+ik;
disp(['Percentage Killed ' num2str(100*ik/tot)]);
disp(['Percentage Alive ' num2str(100*ia/tot)]);
disp(['Percentage Dud ' num2str(100*id/(tot+id))]);
diary off



