% The Benchmark Problem 001 Code
% This file is used for the mutant generation
% (c) Yogananda Jeppu yvj_2000@yahoo.com
% Initialize all variables
ppdf01 = 0;
pdf01 = 0;
pposat0 = 0;
posat0 = 0;
ppdf02 = 0;
pdf02 = 0;
pposat1 = 0;
posat1 = 0;
pofil2 = 0;
posat2 = 0;
pout2 = 0;
pout5 = 0;
ppofil3 = 0;
pofil3 = 0;
pposat4 = 0;
posat4 = 0;
pout7=0;
pointeg2 = 0;
pinro1 = 0;inro1 = 0;
posat3 = 0;
DtOn = 100;
DtOff = 200;
pinper1 = 0; count=0; outper=0;init=1;
pininteg1=0;
posat6 = 0;
% Initialize the output vector and a temporary tapout variable
OUT = zeros(length(t),7);
TEMP=zeros(length(t),5);
% Sample Time used in computation (same as DT)
Ts=0.02; 
delaytemp = [0 0 0 0];  % Initialize delay
% Start iterattions
for ii = 1:length(t)
%START HERE
% Data of the filters
NZ1=[3.951007506914264e-004    7.902015013828528e-004    3.951007506914264e-004];
DZ1=[1.000000000000000e+000   -1.974713551955749e+000    9.762939549585143e-001];
NZ2=[1.536098310291859e-003    3.072196620583717e-003    1.536098310291859e-003];
DZ2=[1.000000000000000e+000   -1.917050691244239e+000    9.231950844854068e-001];
NZ3=[9.090909090909092e+000   -9.090909090909092e+000];
DZ3=[1.000000000000000e+000   -8.181818181818182e-001];
NZ4=[3.462870334744132e-003    6.925740669488265e-003    3.462870334744132e-003];
DZ4=[1.000000000000000e+000   -1.916891111966141e+000    9.307425933051174e-001];
% Table lookup data
XT=sort([-170 -100 -50 25 30 100]);
YT=[10 20 30 40 50 60];
% Assign Inputs taken put from the simulink model
inp1 = INP1(ii);
inp2 = INP2(ii);
inp3 = INP3(ii);
inp4 = INP4(ii);
inp5 = INP5(ii);
inp6 = INP6(ii);
inp7 = INP7(ii);
inp8 = INP8(ii);
inp9 = INP9(ii);
inp10 = INP10(ii);
% Saturation Block OSAT0
if (inp1 < -60)
osat0 = -60;
elseif (inp1 > 60)
osat0 = 60;
else
osat0 = inp1;
end
% Saturation Block OSAT1
if (inp2 < -60)
osat1 = -60;
elseif (inp2 > 60)
osat1 = 60;
else
osat1 = inp2;
end
% Discrete Filter
df01 = NZ1(1)*osat0+NZ1(2)*posat0+NZ1(3)*pposat0-DZ1(2)*pdf01-DZ1(3)*ppdf01;
ppdf01=pdf01;
pdf01=df01;
pposat0=posat0;
posat0=osat0;
%Discrete Filter1
df02 = NZ2(1)*osat1+NZ2(2)*posat1+NZ2(3)*pposat1-DZ2(2)*pdf02-DZ2(3)*ppdf02;
ppdf02=pdf02;
pdf02=df02;
pposat1=posat1;
posat1=osat1;
%Adder Block
inlook01=df01-df02;
% Interpolation
out1=interpol1(XT,YT,inlook01);
% Saturation osat2
if (inp3 < -20)
osat2 = -20;
elseif (inp3 > 10)
osat2 = 10;
else
osat2 = inp3;
end
%Discrete Filter 2
ofil2 = NZ3(1)*osat2+NZ3(2)*posat2-DZ3(2)*pofil2;
pofil2=ofil2;
posat2=osat2;
% Saturation Block osat3
if (ofil2 < -5)
osat3 = -5;
elseif (ofil2 > 5)
osat3 = 5;
else
osat3 = ofil2;
end
% Discrete Integrator with Limits
out2 = posat3*Ts+pout2;
if out2 > 30
out2 = 30;
elseif out2 < -30
out2 = -30;
end
pout2=out2;
posat3 = osat3;
% Xor Logic
xorout = xor(xor(inp6,not(inp8)),inp9);
% Saturation Block osat5
if (inp5 < -3.5)
osat5 = -3.5;
elseif (inp5 > 3.5)
osat5 = 3.5;
else
osat5 = inp5;
end
% Switch
if (xorout)
ininteg1 = osat5;
else
ininteg1 = -1;
end
% Discrete Integrator1 with Limits
out5 = pininteg1*Ts+pout5;
if out5 > 10
out5 = 10;
elseif out5 < -10
out5 = -10;
end
pout5=out5;
pininteg1=ininteg1;
% Saturation Block osat4
if (inp4 < -40)
osat4 = -40;
elseif (inp4 > 40)
osat4 = 40;
else
osat4 = inp4;
end
% Discrete Filter 3
ofil3 = NZ4(1)*osat4+NZ4(2)*posat4+NZ4(3)*pposat4-DZ4(2)*pofil3-DZ4(3)*ppofil3;
ppofil3=pofil3;
pofil3=ofil3;
pposat4=posat4;
posat4=osat4;
% Addrer Block
oadd1 = out5 + ofil3;
% Relational operator
if oadd1 >= 70
out3 = 1;
else
out3 = 0;
end
% Rate Limiter Dynamic 1
ul = 10*Ts;
ll = -10*Ts;
itemp = inp7-pout7;
if itemp > ul
out7 = ul+pout7;
elseif itemp < ll
out7 = pout7+ll;
else
out7 = pout7+itemp;
end
pout7 = out7;
% Delay 4 samples
delayo = delaytemp(1);
for i = 1:3
delaytemp(i) = delaytemp(i+1);
end
delaytemp(4) = out7;
% Add2
inro2 = delayo - out7;
% Relational operator 2
oro2 = (inro2 >= 0.6);
% Relational operator 3
oro3 = ( out7 < -80 );
% AND block
out4 = and(oro3,oro2);
% Saturation Block osat6
if (inp10 < -100)
osat6 = -100;
elseif (inp10 > 100)
osat6 = 100;
else
osat6 = inp10;
end
% Discrete Integrator
ointeg2 = posat6*Ts+pointeg2;
pointeg2=ointeg2;
posat6=osat6;
% Hysterisis
bw=100;
if ointeg2 > (pinro1 +bw/2)
inro1 = ointeg2-(bw/2);
elseif ointeg2 < (pinro1 -bw/2)
inro1 = ointeg2+(bw/2);
end
pinro1 = inro1 ;
% Relational Operator 1
inper1 = (inro1 >= 250);
% Peristence
if (inper1)
dtx = DtOn;
else
dtx = DtOff;
end
if inper1~=pinper1
count=0;
end
count = count+1;
if count > dtx
outper = inper1;
end
if init == 1
outper = 0;
count = 1;
init = 0;
end
pinper1=inper1;
out6 = outper;
%END HERE    
% Tap out all the outputs
OUT(ii,:) = [out1 out2 out3 out4 out5 out6 out7];
end

% End of iterations

% plot(t,OUT-[simout1 simout2 simout3 simout4 simout5 simout6 simout7]);shg

% Compute Error between model and matlab
err=max(max(abs(OUT-[simout1 simout2 simout3 simout4 simout5 simout6 simout7])));