% Random Test case Generator looking at coverage

% (c) Yogananda Jeppu yvj_2000@yahoo.com

clc
clear all
DT=0.02;
t=0:DT:50;t=t';   % Define time vector

testcases = zeros(1000,30);   % Test vector parameter store
COVERAGES=zeros(1000,76);

ic = 100;  % Data save at every 100 iterations
warning off

for ix = 1:1000
    f=rand*3+0.01;a=200*rand+0.1;b=rand*20-10;
    inp1=sin(2*pi*f*t)*a+b;
    testcases(ix,1) = f; testcases(ix,2) = a; testcases(ix,3) = b;
    
    f=rand*3+0.01;a=200*rand+0.1;b=rand*20-10;
    inp2=sin(2*pi*f*t)*a+b;
    testcases(ix,4) = f; testcases(ix,5) = a; testcases(ix,6) = b;
    
    f=rand*1+0.001;a=200*rand+0.1;b=rand*20-10;
    inp3=sin(2*pi*f*t)*a+b;
    testcases(ix,7) = f; testcases(ix,8) = a; testcases(ix,9) = b;
    
    f=rand*3+0.01;a=100*rand+0.1;b=rand*20-10;
    inp4=sin(2*pi*f*t)*a+b;
    testcases(ix,10) = f; testcases(ix,11) = a; testcases(ix,12) = b;
    
    f=rand*3+0.01;a=100*rand+0.1;b=rand*20-10;
    inp5=sin(2*pi*f*t)*a+b;
    testcases(ix,13) = f; testcases(ix,14) = a; testcases(ix,15) = b;
    
    f=rand*0.1+0.01;a=100*rand+0.1;b=rand*20-10;
    inp6=sin(2*pi*f*t)*a+b;
    testcases(ix,16) = f; testcases(ix,17) = a; testcases(ix,18) = b;
    
    f=rand*3+0.01;a=100*rand+0.1;b=rand*20-10;
    inp7=sin(2*pi*f*t)*a+b;
    testcases(ix,19) = f; testcases(ix,20) = a; testcases(ix,21) = b;
    
    f=rand*0.1+0.01;a=100*rand+0.1;b=rand*20-10;
    inp8=sin(2*pi*f*t)*a+b;
    testcases(ix,22) = f; testcases(ix,23) = a; testcases(ix,24) = b;
    
    f=rand*0.1+0.01;a=100*rand+0.1;b=rand*20-10;
    inp9=sin(2*pi*f*t)*a+b;
    testcases(ix,25) = f; testcases(ix,26) = a; testcases(ix,27) = b;
    
    f=rand*3+0.01;a=100*rand+0.1;b=rand*20-10;
    inp10=sin(2*pi*f*t)*a+b;
    testcases(ix,28) = f; testcases(ix,29) = a; testcases(ix,30) = b;
    
    %
    sim('compete_2010');
    model0001_c
    COVERAGES(ix,:) = COVERAGE;
    
    if ix >= ic
        ic=ic+100;
        disp(['Done ' num2str(ix)])
        save data testcases COVERAGES
    end
    
end
find( (sum(COVERAGES) > 0) == 0)




